library bitbtn;

uses Classes, QControls, Rubies, Pythia, QButtons;

{$IFDEF LINUX}
{$SONAME 'bitbtn.so'}

{$ENDIF}

var
  cBitBtn: Tvalue;

procedure BitBtn_setup(obj: Tvalue; real: TBitBtn);
begin
  rb_iv_set(obj, '@glyph', Bitmap_alloc(ap_cBitmap, real.Glyph));
  Button_setup(obj, real);
end;

function BitBtn_new(argc: integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
var
  real: TBitBtn;
begin
  real := TBitBtn.Create(nil);
  result := CompoAlloc(This, real);
  CompoSetup(argc, argv, real);
  BitBtn_setup(result, real);
  rb_obj_call_init(result, argc, argv);
end;

procedure Init_bitbtn; cdecl;
begin
  cBitBtn := DefineCompoClass(ap_mPhi, TBitBtn, ap_cButton, nil);
  DefineSingletonMethod(cBitBtn, 'new', BitBtn_new);
  DefineConstSetType(ap_mPhi, TypeInfo(TBitBtnKind));
end;

exports
  Init_bitbtn;

begin

end.
