library phi;

uses
  PhiMainUnit,
  Types, SysUtils, Classes, QControls, QForms, QMenus,
  Rubies, uStrUtils,
  version,
  uDebug, uCdecl, uHandle, uIntern, uAlloc, uProp, uConv,
  uPhi, uError, uIO, uPropInfo, uTypeInfo, uMarshal, uFunc, uThread,
  uShiftState,
  uFontCharset, uModalResult, uColor, uCursor,
  uPoint, uSize, uRect, uSizeConstraints, uDateTime,
  uSys,
  uStream, uStrings, uScreen, uClipboard,
  uIcon, uFont, uBrush, uPen,
  uDragObject, uCanvas, uBitmap,
  uPicture, uApplication,
  uComponent, uControl, uForm, uFrame, uMenuItem, uMenu,
  uLabel, uButton, uEdit, uMemo,
  uCheckBox, uRadioButton, uListBox,
  uComboBox, uScrollBar, uGroupBox, uRadioGroup, uPanel,
  uSpeedButton, uMaskEdit, uGrid, uImage, uShape, uScrollBox, uSplitter,
  uPageControl, uTabSheet,
  uTreeNode, uTreeView,
  uListItem, uListColumn, uListView,
  uStatusBar, uTimer, uPaintBox;

{$IFDEF LINUX}
{$SONAME 'phi.so'}
{$ENDIF}

exports
 Init_phi;

exports
  ap_dispose,
  ObjFree,
  ChildFree,
  CompoFree,
  FormRelease,
  CompoAlloc,
  FormAlloc,
  ChildAlloc,
  ObjAlloc,
  TmpAlloc;

exports
  ap_cApplication;

exports
  ap_cBitmap,
  Bitmap_alloc;

exports
  ap_cBrush,
  Brush_alloc;

exports
  ap_cButton,
  Button_setup,
  Button_alloc;

exports
  ap_cCanvas,
  Canvas_alloc;

exports
  GetCallbackMethod;

exports
  ap_cCheckBox,
  CheckBox_alloc;

exports
  ap_cClipboard;

exports
  ap_cComboBox,
  ComboBox_alloc;

exports
  RemoveParentAttr,
  ap_cComponent,
  CompoSetup,
  DefineCompoClass;

exports
  ClearEvents,
  ap_cControl,
  ap_cWinControl;

exports
  dl_Boolean,
  ap_Fixnum,
  dl_Integer,
  ap_Float,
  dl_Double,
  ap_String,
  dl_String,
  ap_Variant,
  dl_Variant,
  ap_set_to_ary,
  dl_ary_to_set,
  dl_ClassName;

exports
  ap_DateTime,
  dl_DateTime,
  ap_cDateTime,
  DateTime_alloc;

exports
  ap_cDragObject,
//  ap_cDragDockObject,
  DragObject_alloc;
//  DragDockObject_alloc;

exports
  ap_cEdit,
  Edit_alloc;

exports
  PhiErrorFile,
  PhiErrorLine,
  ap_eDelphiError;

exports
  ap_cFont,
  Font_alloc;

exports
  ap_cForm,
  Form_alloc;

exports
  ap_cCustomGrid,
  ap_cDrawGrid,
  ap_cStringGrid;

exports
  ap_cGroupBox,
  GroupBox_alloc;

exports
  PhiExtentList,
  PhiObjectList,
  PhiAllocFuncList,
  PhiEventFuncList,
  PhiHandle;

exports
  ap_cIcon,
  Icon_alloc;

exports
  ap_cImage,
  Image_alloc,
  ap_cImageList;

exports
  ap_cLabel,
  Label_alloc;

exports
  ap_cListBox,
  ListBox_alloc;

exports
  ap_cListColumn,
  ap_cListColumns,
  ListColumn_alloc,
  ListColumns_alloc;

exports
  ap_cListItem,
  ap_cListItems,
  ListItem_alloc,
  ListItems_alloc;

exports
  ap_cListView,
  ListView_alloc;

exports
  ap_cMemo,
  Memo_alloc;

exports
  ap_cMainMenu,
  MainMenu_alloc,
  ap_cPopupMenu,
  PopupMenu_alloc;

exports
  ap_cMenuItem,
  MenuItem_alloc;

//exports
//  ap_cMetafile,
//  Metafile_alloc;

exports
  ap_cPageControl,
  PageControl_alloc;

exports
  ap_cPaintBox,
  PaintBox_alloc;

exports
  ap_cPanel,
  Panel_alloc;

exports
  ap_cPen,
  Pen_alloc;

exports
  ap_mPhi,
  StringOrSymbolToStr;

exports
  ap_cPicture,
  Picture_alloc;

exports
  ap_cPoint,
  Point_alloc;

exports
  DefineAttrMethod,
  DefineAttrMethod_retval,
  DefineModuleAttrMethod,

  GetEnumName0,
  GetEnumProp0,
  GetEnumProp1,
  GetSetProp0,
  GetSetProp1,
  ap_get_str_prop,

  AssignPropMethod,
  DefineProp,
  DefineConstSetType;

exports
  ap_cRadioButton,
  RadioButton_alloc;

exports
  ap_cRadioGroup,
  RadioGroup_alloc;

exports
  ap_cRect,
  Rect_alloc;

//exports
//  ap_cRichEdit,
//  RichEdit_alloc;

exports
  ap_cScreen,
  ap_vScreen;

exports
  ap_cScrollBar,
  ScrollBar_alloc;

exports
  ap_cScrollBox,
  ScrollBox_alloc;

exports
  ap_cShape,
  Shape_alloc;

exports
  ap_cSize,
  Size_alloc;

exports
  ap_cSizeConstraints,
  SizeConstraints_alloc;

exports
  ap_cSpeedButton,
  SpeedButton_setup,
  SpeedButton_alloc;

exports
  ap_cSplitter,
  Splitter_alloc;

exports
  ap_cStatusBar,
  StatusBar_alloc;

exports
  ap_cStream;

exports
  ap_cStrings,
  Strings_alloc;

exports
  ap_mSys;

exports
  ap_cTabSheet,
  TabSheet_alloc;

exports
  ap_cThread,
  Thread_alloc;

exports
  ap_cTimer,
  Timer_alloc;

exports
  ap_cTreeNode,
  ap_cTreeNodes,
  TreeNode_alloc,
  TreeNodes_alloc;

exports
  ap_cTreeView,
  TreeView_alloc;

//exports
//  ap_mWin;

exports
  ap_cMaskEdit,
  MaskEdit_alloc;

exports
  ap_vTypeInfo;

exports
  UpperCase1,
  LowerCase1;

end.
