unit uHandle;

interface

uses Classes, Contnrs, Rubies, PhiHandle;

var
  UOwner: TComponent;
  Handle: TPhiHandle;

function retnil(argc: Integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
function retval(argc: Integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
function PhiExtentList: TObjectList; stdcall;
function PhiObjectList: TObjectList; stdcall;
function PhiAllocFuncList: TStringList; stdcall;
function PhiEventFuncList: TStringList; stdcall;
function PhiHandle: TPhiHandle; stdcall;
function PhiUOwner: TComponent; stdcall;

implementation

function retnil(argc: Integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
begin
  result := Qnil;
end;

function retval(argc: Integer; argv: Pointer; This: Tvalue): Tvalue; cdecl;
begin
  if argc > 0 then
    result := Pvalue(argv)^
  else
    result := Qnil
  ;
end;

function PhiExtentList: TObjectList; stdcall;
begin
  result := Handle.ExtentList;
end;

function PhiObjectList: TObjectList; stdcall;
begin
  result := Handle.ObjectList;
end;

function PhiAllocFuncList: TStringList; stdcall;
begin
  result := Handle.AllocFuncList;
end;

function PhiEventFuncList: TStringList; stdcall;
begin
  result := Handle.EventFuncList;
end;

function PhiHandle: TPhiHandle; stdcall;
begin
  result := Handle;
end;

function PhiUOwner: TComponent; stdcall;
begin
  result := UOwner;
end;

end.
