unit uPen;

interface

uses QGraphics, Rubies;

var
  cPen: Tvalue;

function ap_cPen: Tvalue; stdcall;
function Pen_alloc(This: Tvalue; real: TPen): Tvalue; stdcall;
procedure Init_Pen;

implementation

uses uIntern, uAlloc, uProp, uPhi;

function ap_cPen: Tvalue; stdcall;
begin
  result := cPen;
end;

function Pen_alloc(This: Tvalue; real: TPen): Tvalue; stdcall;
begin
  result := TmpAlloc(This, real);
end;

function Pen_new(This: Tvalue): Tvalue; cdecl;
var
  real: TPen;
begin
  real := TPen.Create;
  result := ObjAlloc(This, real);

  rb_obj_call_init(result, 0, nil);
end;

procedure Init_Pen;
begin
  DefineConstSetType(mPhi, TypeInfo(TPenMode));
  DefineConstSetType(mPhi, TypeInfo(TPenStyle));

  cPen := rb_define_class_under(mPhi, 'Pen', ap_cObject);
  DefineProp(cPen, TPen);

  rb_define_singleton_method(cPen, 'new', @Pen_new, 0);
end;

end.
