unit uSys;

interface

uses Rubies, SysUtils;

var
  mSys: Tvalue;

function ap_mSys: Tvalue;
procedure Init_Sys;

implementation

uses uStrUtils;

function ap_mSys: Tvalue;
begin
  result := mSys;
end;

function Sys_beep: Tvalue; cdecl;
begin
  beep;
  result := Qnil;
end;

procedure Init_Sys;
begin
  mSys := rb_define_module('Sys');

  ap_define_const(mSys, 'fmOpenRead', INT2FIX(fmOpenRead));
  ap_define_const(mSys, 'fmOpenWrite', INT2FIX(fmOpenWrite));
  ap_define_const(mSys, 'fmOpenReadWrite', INT2FIX(fmOpenReadWrite));
//  ap_define_const(mSys, 'fmShareCompat', INT2FIX(fmShareCompat));
  ap_define_const(mSys, 'fmShareExclusive', INT2FIX(fmShareExclusive));
  ap_define_const(mSys, 'fmShareDenyWrite', INT2FIX(fmShareDenyWrite));
//  ap_define_const(mSys, 'fmShareDenyRead', INT2FIX(fmShareDenyRead));
  ap_define_const(mSys, 'fmShareDenyNone', INT2FIX(fmShareDenyNone));

  rb_define_module_function(mSys, 'beep', @Sys_beep, 0);
end;

end.
